import { EntityInventoryComponent } from "@minecraft/server";

function hasTag(itemStack, tag, tagRegexp = null) {
    return itemStack
        .getTags()
        .find(itemTag => tagRegexp ? tagRegexp.test(itemTag) : itemTag == tag);
}

function findItemsWithTag(player, itemTag) {
    const playerInventoryContainer = player.getComponent(EntityInventoryComponent.componentId).container;
    const items = [];

    for (let slot = 0; slot < playerInventoryContainer.size; slot++) {
        const itemStack = playerInventoryContainer.getItem(slot);

        if (itemStack && hasTag(itemStack, itemTag)) items.push({ itemStack, slot });
    }
    return items;
}

export {
    hasTag,
    findItemsWithTag
}