import breakeable from "../data/breakeable";
import { hasTag } from "../functions";
import { EntityEquippableComponent, EquipmentSlot } from "@minecraft/server";

export default {
    execute(player) {
        const playerEquipmentComponent = player.getComponent(EntityEquippableComponent.componentId);
        const helmetItemStack = playerEquipmentComponent.getEquipment(EquipmentSlot.Head);

        if (!helmetItemStack || !hasTag(helmetItemStack, "horned_break")) return;
        const { location, dimension } = player;
        const aboveLocation = this.aboveVector(location);
        const aboveHeadBlock = dimension.getBlock(aboveLocation);
        const matchesId = (blockId) => aboveHeadBlock ? aboveHeadBlock.permutation.matches(blockId) : false;
        
        if (!aboveHeadBlock || !breakeable.some(matchesId)) return;
        player.runCommandAsync(`setblock ${aboveLocation.x} ${aboveLocation.y} ${aboveLocation.z} air destroy`);
    },
    aboveVector(vector) {
        return { ...vector, y: vector.y + 1.9 };
    }
}